/* Admin.h: Interface to the tns admin connection handler. */

#ifndef ADMIN_H
#define ADMIN_H

#include "Array.h"

class Spool;
class Connection;
class Config;

struct Remote_group {
    char *name;
    char *flags;
    char *desc;
};
typedef Array<Remote_group, 9, 4> groups;

class Admin {
    Spool *spool;
    Connection *conn;
    Config *config;
    int running;

    int handle_command(const char *s, int len, const char *rest);
    void newgroup(const char *s);
    void takegroups(const char *s);
    void quit(const char *s);

  public:
    Admin(Spool *spool_arg, Connection *conn_arg, Config *config_arg);
    ~Admin();
    void run();
};

#endif

