/* Array.cc: Implementation of a resizable array. */

#include "threads.h"
#include "util.h"

#include "Array.h"

#pragma implementation

template<class T, int MIN_POWER, int DELTA>
Array<T, MIN_POWER, DELTA>::Array(int anticipated)
{
    size = adjust_size(anticipated, MIN_POWER, DELTA);
    ptrs = new T[size];
}

template<class T, int MIN_POWER, int DELTA>
Array<T, MIN_POWER, DELTA>::~Array()
{
    delete[] ptrs;
}

template<class T, int MIN_POWER, int DELTA>
void Array<T, MIN_POWER, DELTA>::ensure(int ind)
{
    T *nptrs;
    int nsize, i;

    if (ind >= size) {
	nsize = adjust_size(ind + 1, MIN_POWER, DELTA);
	nptrs = new T[nsize];
	for (i = 0; i < size; i++)
	    nptrs[i] = ptrs[i];
	delete[] ptrs;
	ptrs = nptrs;
	size = nsize;
    }
}

#include "Pool.h"
#include "Admin.h"

