/* Article.h: Reader interface to news articles on disk. */

#ifndef ARTICLE_H
#define ARTICLE_H

#include "String.h"
#include "Headers.h"

extern "C" {
#include <stdio.h>
}

class Bucket;
class String;
class Connection;

class Article {
    FILE *fp;
    Bucket *in_bucket;
    long start_offset, body_offset;
    int body_read;
    Headers headers;

  public:
    Article(Bucket *bucket, FILE *file, long offset);
    ~Article();

    Bucket *bucket() { return in_bucket; }
    long offset() { return start_offset; }
    void get_message_id(String *buf);
    void write_head(Connection *conn);
    void write_body(Connection *conn);
};

#endif

