/* connection.h: Declarations for the connection class. */

#ifndef CONNECTION_H
#define CONNECTION_H

#include "String.h"

enum Name_status { NAME_OK, NAME_FORGED, NAME_NONE, NAME_NOTSOCKET };

class Connection {

  private:
    int client_socket;
    int flags;
    String inbuf;
    String outbuf;
    char peer_ip[64];
    char *peer_name;
    Name_status peer_name_status;

    int read(char *buf, int buf_size);
  public:
    Connection(int fd);
    ~Connection();

    const char *name() { return peer_name; }
    const char *ip() { return peer_ip; }
    int read_line(String *buf);
    int read_line_clear(String *buf);

    void write(const char *s, int len);
    void write(const char *s) { write(s, strlen(s)); }
    void write(String *line) { write(line->chars(), line->length()); }
    void writef(const char *fmt, ...); 
    void flush_outbuf();
};

#endif

