/* Feeds.h: Interface to the newsfeeds manager */

#ifndef FEEDS_H
#define FEEDS_H

#include "String.h"

extern "C" {
#include <sys/types.h>
}

class Newsfeed;
class String;
class Config;
class Headers;
class Spool;

struct Newsfeed_list {
    Newsfeed *feed;
    Newsfeed_list *next;
};

class Feeds {
    Newsfeed_list *newsfeeds;

  public:
    Feeds(Spool *spool, const Config *config);
    ~Feeds();
    int propagate_article(int partition, time_t bucket_num, long offset,
			  const Headers *headers, const char *body);
};

#endif

