/* Headers.h: Interface to structure for storing article headers. */

#ifndef HEADERS_H
#define HEADERS_H

extern "C" {
#include <stdio.h>
}

const int HEADER_HASHTAB_SIZE = 37;

struct Field;

class Headers {
    Field *hashtab[HEADER_HASHTAB_SIZE];
    Field *first;
    Field *last;
    Field *current;

    Field *Headers::find_entry(const char *name, int len) const;

  public:
    Headers();
    ~Headers();

    int add_header(const char *line);
    int add_header(const char *line, int len);
    int add_headers(FILE *fp);
    const char *add_headers(const char *lines);
    Field *find_field(const char *name, int len) const;
    const char *find_value(const char *name) const;
    const char *find_value(const char *name, int len) const;
    const char *first_header();
    const char *next_header();
    void clear();
    const char *operator [](const char *name) const
	{ return find_value(name); }
};

#endif

