/* Newsfeed.h: Interface to a site's newsfeed handler. */

#ifndef FEED_H
#define FEED_H

#include "String.h"

extern "C" {
#include <stdio.h>
#include <sys/types.h>
}

class Config;
class Headers;
class Connection;
class Spool;
template<class Value> class Wildcard_list;

class Newsfeed {
    char *name;
    Spool *spool;
    Wildcard_list<bool> *groups_list;
    Wildcard_list<bool> *dists_list;
    Wildcard_list<bool> *paths_list;
    int work_flag;
    Condition work;
    Mutex file_lock;
    FILE *queue_file;
    String dirname;
    String queue_filename;
    String work_filename;

    void feed_articles_in_file(FILE *fp);
    int feed_article(Connection *conn, int partition, time_t bucket_num,
		     int offset);
    Connection *make_connection();
    int wanted(const Headers *headers);
    int queue_article(int partition, time_t bucket_num, long offset);

  public:
    /* spec and dirname must be valid for the lifetime of the feed. */
    Newsfeed(const char *name_arg, Spool *spool_arg, const Config *config);
    ~Newsfeed();
    void feed_articles();
    int propagate_article(int partition, time_t bucket_num, long offset,
			  const Headers *headers, const char *body);
};

#endif

