/* Nntp.h: Declarations for the Nntp procool-handling class. */

#ifndef NNTP_H
#define NNTP_H

#include "Spool.h"
#include "String.h"

class Connection;
class Newsgroup;
class Article;
class Config;
template<class Value> class Wildcard_list;

class Nntp {
    Spool *spool;
    Connection *conn;
    Config *config;
    Newsgroup *cur_group;
    Article *cur_article;
    int cur_index;
    int running;
    String message_id;
    String spool_message;
    Wildcard_list<bool> *post_access;
    Wildcard_list<bool> *read_access;
    Wildcard_list<bool> *transfer_access;

    int handle_command(const char *s, int len, const char *rest);
    void article(const char *s);
    void body(const char *s);
    void group(const char *s);
    void head(const char *s);
    void help(const char *s);
    void ihave(const char *s);
    void last(const char *s);
    void list(const char *s);
    void newgroups(const char *s);
    void newnews(const char *s);
    void next(const char *s);
    void post(const char *s);
    void quit(const char *s);
    void slave(const char *s);
    void stat(const char *s);
    void xhdr(const char *s);
    void xover(const char *s);

    void fetch_article(const char *s, int head, int body);
    int select_first_article();

  public:
    Nntp(Spool *spool_arg, Connection *conn_arg, Config *config_arg);
    ~Nntp();
    void run();
};

#endif

