/* String.h: Declarations for the String class. */

#ifndef STRING_H
#define STRING_H

class String {

    int string_length;
    int string_size;
    char *string_chars;

    void initialize(int anticipated_length);

  public:
    String();
    String(int anticipated_length);
    String(const char *s);
    String(const char *s, int len);
    String(const String &str);
    ~String();

    /* Information retrieval */
    int length() const { return string_length; }
    const char *chars() const { return string_chars; }

    /* Mutators.  All of these should be obvious except perhaps "shift",
     * which removes characters from the left side of a string. */
    void append(const char *s, int len);
    void append(const char *s) { append(s, strlen(s)); }
    void append(char c) { append(&c, 1); }
    void append(const String *str) { append(str->chars(), str->length()); }
    void truncate(int len);
    void clear() { truncate(0); }
    void shift(int start);
    void reverse();
    void strip_trailing_whitespace();
    void substitute(const char *what, const char *with);
};

#endif

