/* Admin.h: Interface to the tns admin connection handler. */

#ifndef ADMIN_H
#define ADMIN_H

#include "Array.h"
#include "String.h"

class Spool;
class Connection;
class Config;

struct Remote_group {
    Stored_string name;
    Stored_string flags;
    Stored_string desc;
};
typedef Array<Remote_group, 9, 4> groups;

class Admin {
    Spool *spool;
    Connection *conn;
    Config *config;
    int running;

    int handle_command(String s, String rest);
    void drain(String s);
    void expire(String s);
    void getgroups(String s);
    void help(String s);
    void list(String s);
    void mergegroups(String s);
    void newgroup(String s);
    void shutdown(String s);
    void throttle(String s);
    void quit(String s);

  public:
    Admin(Spool *spool_arg, Connection *conn_arg, Config *config_arg);
    ~Admin();
    void run();
};

#endif

