/* Array.cc: Implementation of a resizable array. */

#include "threads.h"

#include "Array.h"

template<class T, int MIN_POWER, int DELTA>
Array<T, MIN_POWER, DELTA>::Array()
{
    size = 0;
}

template<class T, int MIN_POWER, int DELTA>
Array<T, MIN_POWER, DELTA>::Array(int anticipated)
{
    size = adjust_size(anticipated, MIN_POWER, DELTA);
    ptr = new T[size];
}

template<class T, int MIN_POWER, int DELTA>
Array<T, MIN_POWER, DELTA>::~Array()
{
    if (size)
	delete[] ptr;
}

template<class T, int MIN_POWER, int DELTA>
void Array<T, MIN_POWER, DELTA>::ensure(int ind)
{
    T *nptr;
    int nsize, i;

    if (ind >= size) {
	nsize = adjust_size(ind + 1, MIN_POWER, DELTA);
	nptr = new T[nsize];
	for (i = 0; i < size; i++)
	    nptr[i] = ptr[i];
	if (size)
	    delete[] ptr;
	ptr = nptr;
	size = nsize;
    }
}

template<class T, int MIN_POWER, int DELTA>
List<T, MIN_POWER, DELTA>::List()
{
    l = 0;
}

template<class T, int MIN_POWER, int DELTA>
void List<T, MIN_POWER, DELTA>::add(T item)
{
    items.ensure(l);
    items[l] = item;
    l++;
}

template<class T, int MIN_POWER, int DELTA>
T *List<T, MIN_POWER, DELTA>::next()
{
    items.ensure(l);
    l++;
    return &items[l - 1];
}

template<class T, int MIN_POWER, int DELTA>
void List<T, MIN_POWER, DELTA>::remove(int n)
{
    l--;
    for (; n < l; n++)
	items[n] = items[n + 1];
}

int Stringlist::find_case(String str)
{
    int i;

    for (i = 0; i < len(); i++) {
	if (compare_case((*this)[i].str(), str) == 0)
	    return i;
    }
    return -1;
}


/* Return the smallest number N such that N >= size and N = 2^B - delta for
 * some B >= min_bits. */
int adjust_size(int size, int min_power, int delta)
{
    int b;

    size += delta - 1;
    b = min_power;
    while ((size >> b) != 0)
	b++;
    return (1 << b) - delta;
}

#include "Config.h"
#include "Pool.h"
#include "Admin.h"
#include "Wildcard_list.h"
#include "String.h"
template class List<Pattern<Expire_spec>, 3, 3>;
template class List<Pattern<bool>, 3, 3>;
template class List<Pattern<int>, 3, 3>;
template class List<Pattern<char *>, 3, 3>;
template class List<Pattern<Stored_string>, 3, 3>;
template class List<Stored_string, 4, 4>;
template class Array<Remote_group, 9, 4>;
template class Array<char, 7, 32>;
template class Array<Pattern<Expire_spec>, 3, 3>;
template class Array<Pattern<bool>, 3, 3>;
template class Array<Pattern<int>, 3, 3>;
template class Array<Pattern<char *>, 3, 3>;
template class Array<Pattern<Stored_string>, 3, 3>;
template class Array<Stored_string, 4, 4>;
template class Array<struct Partition, 4, 4>;

