/* Array.h: Interface for a resizable array. */

#ifndef ARRAY_H
#define ARRAY_H

#include "String.h"

template<class T, int MIN_POWER, int DELTA> class Array {
    T *ptr;
    int size;

  public:
    explicit Array();
    explicit Array(int anticipated);
    ~Array();
    void ensure(int i);
    T& operator [](int ind) const { return ptr[ind]; }
    T* base() const { return ptr; }
};

template<class T, int MIN_POWER, int DELTA> class List {
    Array<T, MIN_POWER, DELTA> items;
    int l;

  public:
    /* Constructors. */
    explicit List();

    /* Accesors. */
    T& operator[](int n) const { return items[n]; }
    int len() const { return l; }

    /* Mutators. */
    void add(T item);
    T *next();
    void remove(int n);
};

class Stringlist : public List<Stored_string, 4, 4> {
  public:
    void add(String str) { List<Stored_string, 4, 4>::add(Stored_string());
			   (*this)[len() - 1].store(str); }
    int find_case(String str);
};

int adjust_size(int size, int min_power, int delta);

#endif

