/* Atomic_file.h: Interface to module for atomically updating a file. */

#ifndef ATOMIC_FILE_H
#define ATOMIC_FILE_H

#include "String.h"

extern "C" {
#include <stdio.h>
}

/* all open_read() to open the file for reading, and call fclose() on the file
 * handle when you're done using it.  To update the file, call open_new() and
 * write to the file handle returned; close if with fclose() and call update()
 * to perform the update. */
class Atomic_file {
    Stored_string name;
    Stored_string old_name;
    Stored_string new_name;

  public:
    Atomic_file(String);

    FILE *open_read();
    FILE *open_new();
    int update();
};

#endif

