/* connection.h: Declarations for the connection class. */

#ifndef CONNECTION_H
#define CONNECTION_H

#include "Stringbuf.h"

enum Name_status { NAME_OK, NAME_FORGED, NAME_NONE, NAME_NOTSOCKET };

class Connection {

  private:
    int client_socket;
    int flags;
    Stringbuf inbuf;
    Stringbuf outbuf;
    Stored_string peer_ip;
    Stored_string peer_name;
    Name_status peer_name_status;

    int get_data();
  public:
    Connection(int fd);
    ~Connection();

    String name() { return peer_name.str(); }
    String ip() { return peer_ip.str(); }
    int read_line(Stringbuf *buf);
    int read_line_clear(Stringbuf *buf);

    void write(String str);
    void writef(String fmt, ...); 
    void flush_outbuf();
};

#endif

