/* Headers.h: Interface to structure for storing article headers. */

#ifndef HEADERS_H
#define HEADERS_H

extern "C" {
#include <stdio.h>
}

const int HEADER_HASHTAB_SIZE = 37;

struct Field;

class Headers {
    Field *hashtab[HEADER_HASHTAB_SIZE];
    Field *first;
    Field *last;
    Field *current;

    Field *find_field(String name) const;

  public:
    Headers();
    ~Headers();

    int add_header(String line);
    int add_headers(FILE *fp);
    String add_headers(String lines);
    String find_value(String name) const;
    String first_header();
    String next_header();
    void clear();
    String operator [](String name) const { return find_value(name); }
};

#endif

