/* Nntp.h: Declarations for the Nntp procool-handling class. */

#ifndef NNTP_H
#define NNTP_H

#include "Spool.h"
#include "String.h"
#include "Stringbuf.h"

class Connection;
class Newsgroup;
class Article;
class Config;
template<class Value> class Wildcard_list;

class Nntp {
    Spool *spool;
    Connection *conn;
    Config *config;
    Newsgroup *cur_group;
    Article *cur_article;
    int cur_number;
    int running;
    Stringbuf message_id;
    Stringbuf spool_message;
    Wildcard_decision_list *post_access;
    Wildcard_decision_list *read_access;
    Wildcard_decision_list *transfer_access;

    int handle_command(String cmd, String rest);
    void article(String s);
    void body(String s);
    void group(String s);
    void head(String s);
    void help(String s);
    void ihave(String s);
    void last(String s);
    void list(String s);
    void newgroups(String s);
    void newnews(String s);
    void next(String s);
    void post(String s);
    void quit(String s);
    void slave(String s);
    void stat(String s);
    void xhdr(String s);
    void xover(String s);

    void fetch_article(String s, int head, int body);
    int select_first_article();

  public:
    Nntp(Spool *spool_arg, Connection *conn_arg, Config *config_arg);
    ~Nntp();
    void run();
};

#endif

