/* wildcard_test.cc: Unit test driver for wildcard matching. */

#include "threads.h"
#include "util.h"

extern "C" {
#include <stdio.h>
#include <string.h>
}

static void verify(char *pattern, char *s, int value);
static int err = 0;

int main()
{
    verify("foo", "foo", 1);
    verify("foo", "bar", 0);
    verify("*", "foo", 1);
    verify("foo*", "foobar", 1);
    verify("foo*", "foo", 1);
    verify("foo*", "barbar", 0);
    verify("*foo", "barfoo", 1);
    verify("*foo", "foo", 1);
    verify("*foo", "barfoobar", 0);
    verify("*foo*", "barfoobar", 1);
    verify("*foo*", "foo", 1);
    verify("*foo*", "barfobar", 0);
    verify("*foo*bar", "bazfoobazbar", 1);
    verify("*foo*bar", "foobar", 1);
    verify("*foo*bar", "bazfobazbar", 0);
    verify("*foo*bar", "bazfoobazba", 0);
    return err;
}

static void verify(char *pattern, char *s, int value)
{
    if (wildcard_match(pattern, s) != value)
	fprintf(stderr, "Mismatch: %s against %s != %d", pattern, s, value);
    err = 1;
}

